package example.com.save;

import android.content.ComponentName;
import android.content.Context;
import android.content.Intent;
import android.net.Uri;
import android.os.Build;
import android.os.Handler;
import android.os.SystemClock;
import android.support.annotation.RequiresApi;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.view.View;
import android.widget.EditText;
import android.widget.TextView;
import android.widget.Toast;
import java.util.Calendar;


public class MainActivity extends AppCompatActivity{

    private EditText set_time;
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        init();
    }
    //点击事件监听
    @RequiresApi(api = Build.VERSION_CODES.JELLY_BEAN)
    public void onClick(View view){
        int id=view.getId();
        switch (id){
            case R.id.bt_ok:
                if(set_time.getText().toString().equals("")){
                    Toast.makeText(this,"请输入整数",Toast.LENGTH_SHORT).show();
                }else{
                    int limit=Integer.valueOf(set_time.getText().toString());
                    FileProcess.writeInternalData(this,"limit.txt",limit*60);
                    Toast.makeText(this,"已设定提示时间为"+set_time.getText().toString()+"分钟",Toast.LENGTH_LONG).show();
                }

                break;
            case R.id.bt_start:
                Intent intent1=new Intent(this,RecordTimeService.class);
                intent1.setAction("android.intent.action.Service_TimeRecord");
                startService(intent1);
                break;
            case R.id.bt_clear:
                FileProcess.writeInternalData(this,"time.txt",0);
                FileProcess.writeInternalData(this,"time2.txt",0);
                int time2=(int)(SystemClock.elapsedRealtime()/1000);
                FileProcess.writeInternalData(this,"lasttime.txt",time2);
                Toast.makeText(this,"已清空计时数据",Toast.LENGTH_SHORT).show();
                break;
            case R.id.bt_read:
                //Toast.makeText(this,"使用前需获取自启动权限，然后点击开启服务",Toast.LENGTH_LONG).show();
                startActivity(new Intent(MainActivity.this,DialogActivity.class));
                break;

            case R.id.bt_get:
                Intent intent=getAutostartSettingIntent(this);
                startActivity(intent);
                break;
//            case R.id.bt_help:
//                Toast.makeText(this,"使用前需获取自启动权限，然后点击开启服务",Toast.LENGTH_LONG).show();
//                break;
            case R.id.bt_sound:
                MainActivity.this.startActivity(new Intent(MainActivity.this,SoundActivity.class));
                break;
            default:
                break;

        }
    }

    /**
     * 初始化界面
     */

    public void init(){

        setContentView(R.layout.activity_main);
        set_time=(EditText)findViewById(R.id.ettv_limit);
        //开启线程每隔两秒更新一次UI数据
        final TextView tv_time=(TextView)findViewById(R.id.tv_time);
        Handler mTimeHandler = new Handler() {
            public void handleMessage(android.os.Message msg) {
                if (msg.what == 0) {
                    int n=FileProcess.readInternalData(getApplicationContext(),"time.txt")+FileProcess.readInternalData(getApplicationContext(),"time2.txt");
                    String min=Integer.toString(n/60);
                    String sec=Integer.toString(n%60);
                    tv_time.setText(min+"分"+sec+"秒");
                    sendEmptyMessageDelayed(0, 3000);
                }

            }
        };

        mTimeHandler.sendEmptyMessageDelayed(0, 3000);
    }

    public static void startbootService(Context context){
        Intent intent1=new Intent(context,RecordTimeService.class);
        intent1.setAction("android.intent.action.recordtimeservice");
        context.startService(intent1);
    }
    /**
     * 获取自启动管理页面的Intent
     * 返回自启动管理页面的Intent
     * */
    public static Intent getAutostartSettingIntent(Context context) {
        ComponentName componentName = null;
        String brand = Build.MANUFACTURER;
        Intent intent = new Intent();
        intent.addFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
        switch (brand.toLowerCase()) {
            case "samsung"://三星
                componentName = new ComponentName("com.samsung.android.sm", "com.samsung.android.sm.app.dashboard.SmartManagerDashBoardActivity");
                break;
            case "huawei"://华为
                //荣耀V8，EMUI 8.0.0，Android 8.0上，以下两者效果一样
                componentName = new ComponentName("com.huawei.systemmanager", "com.huawei.systemmanager.appcontrol.activity.StartupAppControlActivity");
//            componentName = new ComponentName("com.huawei.systemmanager", "com.huawei.systemmanager.startupmgr.ui.StartupNormalAppListActivity");//目前看是通用的
                break;
            case "xiaomi"://小米
                componentName = new ComponentName("com.miui.securitycenter", "com.miui.permcenter.autostart.AutoStartManagementActivity");
                break;
            case "vivo"://VIVO
//            componentName = new ComponentName("com.iqoo.secure", "com.iqoo.secure.safaguard.PurviewTabActivity");
                componentName = new ComponentName("com.iqoo.secure", "com.iqoo.secure.ui.phoneoptimize.AddWhiteListActivity");
                break;
            case "oppo"://OPPO
//            componentName = new ComponentName("com.oppo.safe", "com.oppo.safe.permission.startup.StartupAppListActivity");
                componentName = new ComponentName("com.coloros.oppoguardelf", "com.coloros.powermanager.fuelgaue.PowerUsageModelActivity");
                break;
            case "yulong":
            case "360"://360
                componentName = new ComponentName("com.yulong.android.coolsafe", "com.yulong.android.coolsafe.ui.activity.autorun.AutoRunListActivity");
                break;
            case "meizu"://魅族
                componentName = new ComponentName("com.meizu.safe", "com.meizu.safe.permission.SmartBGActivity");
                break;
            case "oneplus"://一加
                componentName = new ComponentName("com.oneplus.security", "com.oneplus.security.chainlaunch.view.ChainLaunchAppListActivity");
                break;
            case "letv"://乐视
                intent.setAction("com.letv.android.permissionautoboot");
            default://其他
                intent.setAction("android.settings.APPLICATION_DETAILS_SETTINGS");
                intent.setData(Uri.fromParts("package", context.getPackageName(), null));
                break;
        }
        intent.setComponent(componentName);
        return intent;
    }

}
